=== modified file 'grackle/tests/test_client.py'
--- grackle/tests/test_client.py	2012-01-11 11:18:15 +0000
+++ grackle/tests/test_client.py	2012-01-11 11:36:08 +0000
@@ -15,20 +15,30 @@
     )
 
 
-class Forked:
+class ForkedFake:
 
-    def __init__(self, func_or_method, *args):
-        self.func_or_method = func_or_method
+    def __init__(self, port, messages=None):
         self.pid = None
-        self.args = args
+        self.port = port
+        self.messages = messages
+        self.read_end, self.write_end = os.pipe()
+
+    def is_ready(self):
+        os.write(self.write_end, 'asdf')
 
     def __enter__(self):
         pid = os.fork()
-        if pid != 0:
-            self.pid = pid
-            return
-        self.func_or_method(*self.args)
+        if pid == 0:
+            self.start_server()
+        self.pid = pid
+        os.read(self.read_end, 1)
+        return
 
+    def start_server(self):
+        service = HTTPServer(('', self.port), FakeGrackleRequestHandler)
+        service.messages = self.messages
+        self.is_ready()
+        service.serve_forever()
 
     def __exit__(self, exc_type, exc_val, traceback):
         os.kill(self.pid, SIGKILL)
@@ -46,24 +56,17 @@
             self.send_error(httplib.BAD_REQUEST)
 
 
-def run_service(port, messages):
-    service = HTTPServer(('', port), FakeGrackleRequestHandler)
-    service.messages = messages
-    service.serve_forever()
-
-
 def fake_grackle_service(client, messages=None):
     if messages is None:
         messages = {}
-    return Forked(run_service, client.port, messages)
+    return ForkedFake(client.port, messages)
 
 
 class TestPutMessage(TestCase):
 
     def test_put_message(self):
-        client = GrackleClient('localhost', 8435)
+        client = GrackleClient('localhost', 8436)
         with fake_grackle_service(client):
-            import time; time.sleep(0.5)
             client.put_message('arch1', 'asdf', StringIO('This is a message'))
             with ExpectedException(Exception, 'wtf'):
                 client.put_message('arch1', 'asdf',

